.form-input-wrapper {
  width: 100%;

  .form-input {
    @include inputPlaceholder() {
      @include themify($themes) {
        color: themed('brand-5');
      }
      font-size: map-get($font-size, 'h5');
      font-weight: 300;
    }
    border: 1px solid;
    border-radius: map-get($radius, 'input');
    padding: map-get($spacing, 'mobile-half');
  }
}

.form-input-wrapper-half {
  max-width: percentage(1 / 2);
}

.form-input-wrapper-third {
  max-width: percentage(1 / 3);
}

.form-input-wrapper-quarter {
  max-width: percentage(1 / 4);
}

.form-input {
  @include themify($themes) {
    border-color: themed('brand-5');
  }
  @include inputPlaceholder() {
    @include themify($themes) {
      color: themed('black');
    }
    font-size: map-get($font-size, 'h5');
    font-weight: 700;
    transition: map-get($transition, 'all-fast');
  }
  border: 0;
  border-bottom: 2px solid;
  font-size: map-get($font-size, 'h5');
  outline: none;
  padding: map-get($spacing, 'mobile-half') map-get($spacing, 'mobile-half') map-get($spacing, 'mobile-half') map-get($spacing, 'desktop');
  width: 100%;

  &:focus {
    @include themify($themes) {
      border-color: themed('brand-secondary');
    }
    @include inputPlaceholder() {
      opacity: 0;
    }

    + .form-label {
      opacity: 1;
      top: -1.5rem;
    }
  }

  + .form-label {
    &:hover {
      cursor: text;
    }
  }

  &:not(:invalid) {
    + .form-label {
      opacity: 1;
      top: -1.5rem;
    }
  }
}

textarea {
  &.form-input {
    font-size: map-get($font-size, 'h6');
    min-height: 20rem;
    resize: vertical;
  }
}

.form-input-select-wrapper {
  @include themify($themes) {
    background: themed('white');
  }
  align-items: center;
  display: flex;
  position: relative;
  width: 100%;

  .form-input-select {
    @include themify($themes) {
      background: linear-gradient(90deg, rgba(themed('white'), 1) 90%, rgba(themed('white'), 0) 90%);
      border-color: themed('brand-5');
      color: themed('black');
    }
    appearance: none;
    border: 0;
    border-radius: map-get($radius, 'input');
    border-style: solid;
    border-width: 1px;
    box-sizing: border-box;
    font-size: map-get($font-size, 'h5');
    margin: 0;
    padding: map-get($spacing, 'mobile-half');
    position: relative;
    width: 100%;
    z-index: 2;

    @include breakpoint(map-get($breakpoints, 'breakpoint-md')) {
      &:hover {
        cursor: pointer;
      }
    }

    &:focus {
      @include themify($themes) {
        background: linear-gradient(90deg, rgba(themed('white'), 1) 90%, rgba(themed('white'), 0) 90%);
        border-color: themed('brand-secondary');
      }
      outline: none;
    }
  }

  option {
    @include themify($themes) {
      background: themed('white');
    }
  }

  i {
    @include themify($themes) {
      color: themed('black');
    }
    position: absolute;
    right: 1.5rem;
    z-index: 1;
  }
}

.form-input-checkbox {
  display: inline-flex;

  input {
    &:checked {
      + label {
        &:after {
          transform: rotate(45deg) scale(1);
        }
      }
    }

    &:focus {
      + label {
        &:before {
          @include themify($themes) {
            background-color: rgba(themed('brand-primary'), .8);
          }
        }

        &:after {
          @include themify($themes) {
            border-color: themed('white');
          }
        }
      }
    }

    &:disabled {
      @include themify($themes) {
        background-color: rgba(themed('white'), .5);
      }
    }
  }

  label {
    align-items: start;
    display: flex;
    font-weight: 300;
    position: relative;

    @include breakpoint(map-get($breakpoints, 'breakpoint-md')) {
      &:hover {
        cursor: pointer;
      }
    }

    &:before {
      @include pseudo;
      @include themify($themes) {
        background-color: themed('white');
        border: 1px solid themed('brand-8');
      }
      appearance: none;
      border-radius: map-get($radius, 'checkbox');
      height: 2rem;
      margin-right: 1rem;
      min-width: 2rem;
      outline: none;
      padding: 0;
      position: relative;
      width: 2rem;

      &:hover {
        @include breakpoint(map-get($breakpoints, 'breakpoint-md')) {
          cursor: pointer;
        }
      }
    }

    &:after {
      @include pseudo;
      @include themify($themes) {
        border-color: themed('brand-primary');
      }
      border-style: solid;
      border-width: 0 .1rem .1rem 0;
      height: 1.1rem;
      left: .7rem;
      top: .3rem;
      transform: rotate(45deg) scale(0);
      transition: map-get($transition, 'all-fast');
      width: .6rem;
    }
  }
}

.form-input-radio {
  display: inline-flex;

  input {
    &:checked {
      + label {
        &:after {
          transform: rotate(45deg) scale(1);
        }
      }
    }

    &:focus {
      + label {
        &:before {
          @include themify($themes) {
            background-color: rgba(themed('brand-primary'), .8);
          }
        }

        &:after {
          @include themify($themes) {
            border-color: themed('white');
          }
        }
      }
    }

    &:disabled {
      @include themify($themes) {
        background-color: rgba(themed('white'), .5);
      }
    }
  }

  label {
    align-items: center;
    display: flex;
    font-weight: 300;
    position: relative;

    @include breakpoint(map-get($breakpoints, 'breakpoint-md')) {
      &:hover {
        cursor: pointer;
      }
    }

    &:before {
      @include pseudo;
      @include themify($themes) {
        background-color: themed('white');
        border: 1px solid themed('brand-8');
      }
      appearance: none;
      border-radius: map-get($radius, 'radio');
      height: 2rem;
      margin-right: 1rem;
      outline: none;
      padding: 0;
      position: relative;
      width: 2rem;

      &:hover {
        @include breakpoint(map-get($breakpoints, 'breakpoint-md')) {
          cursor: pointer;
        }
      }
    }

    &:after {
      @include pseudo;
      @include themify($themes) {
        border-color: themed('brand-primary');
      }
      border-style: solid;
      border-width: 0 .1rem .1rem 0;
      height: 1.1rem;
      left: .7rem;
      top: .3rem;
      transform: rotate(45deg) scale(0);
      transition: map-get($transition, 'all-fast');
      width: .6rem;;
    }
  }
}

.form-input-add {
  display: inline-flex;
  max-width: map-get($widths, 'max-width-mini');
  position: relative;
  width: 100%;

  .form-input-wrapper {
    width: 100%;

    input {
      height: map-get($heights, 'button');
      padding-right: map-get($widths, 'add-button');
    }
  }

  .button {
    border-radius: map-get($radius, 'button-nested');
    min-height: calc(#{map-get($heights, 'button') - 1rem});
    position: absolute;
    right: .5rem;
    top: .5rem;

    &:before {
      top: 1.4rem;
    }
  }
}

.form-input-range-row {
  @include breakpoint(max-width map-get($breakpoints, 'breakpoint-md')) {
    grid-gap: 0 2rem;
  }

  span {
    &:first-of-type {
      @include breakpoint(max-width map-get($breakpoints, 'breakpoint-md')) {
        grid-column: 1 / 3!important;
      }
    }

    &:last-of-type {
      @include breakpoint(max-width map-get($breakpoints, 'breakpoint-md')) {
        grid-column: 3 / 5!important;
        text-align: right;
      }
    }
  }

  .card-content-span-two {
    @include breakpoint(max-width map-get($breakpoints, 'breakpoint-md')) {
      grid-row: 2 !important;
    }
  }

  &:nth-of-type(4n+1) {
    input {
      &::-webkit-slider-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-2'));
        }
      }

      &::-moz-range-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-2'));
        }
      }

      &::-ms-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-2'));
        }
      }
    }
  }

  &:nth-of-type(4n+2) {
    input {
      &::-webkit-slider-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-3'));
        }
      }

      &::-moz-range-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-3'));
        }
      }

      &::-ms-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-3'));
        }
      }
    }
  }

  &:nth-of-type(4n+3) {
    input {
      &::-webkit-slider-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-4'));
        }
      }

      &::-moz-range-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-4'));
        }
      }

      &::-ms-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-4'));
        }
      }
    }
  }

  &:nth-of-type(4n+4) {
    input {
      &::-webkit-slider-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-5'));
        }
      }

      &::-moz-range-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-5'));
        }
      }

      &::-ms-thumb {
        @include themify($themes) {
          @include thumb($thumb-color: themed('gradient-5'));
        }
      }
    }
  }
}

.form-input-range {
  align-content: center;
  display: flex;
  position: relative;

  &:before {
    @include themify($themes) {
      background-color: themed('brand-5');
    }
    @include pseudo;
    border-radius: 50%;
    height: 1rem;
    left: -1rem;
    top: calc(50% - .5rem);
    width: 1rem;
  }

  &:after {
    @include themify($themes) {
      background-color: themed('brand-5');
    }
    @include pseudo;
    border-radius: 50%;
    height: 1rem;
    right: -1rem;
    top: calc(50% - .5rem);
    width: 1rem;
  }

  input {
    appearance: none;
    background: transparent;
    margin: 2rem 0;
    position: relative;
    width: 100%;
    z-index: 2;

    &::-moz-focus-outer {
      border: 0;
    }

    &:focus {
      outline: 0;

      &::-webkit-slider-runnable-track {
        @include themify($themes) {
          background: lighten(themed('brand-5'), 5%);
          border: .1rem solid lighten(themed('brand-primary'), 5%);
        }
      }

      &::-ms-fill-lower {
        @include themify($themes) {
          background: themed('brand-5');
          border: .1rem solid themed('brand-primary');
        }
      }

      &::-ms-fill-upper {
        @include themify($themes) {
          background: lighten(themed('brand-5'), 5%);
          border: .1rem solid lighten(themed('brand-primary'), 5%);
        }
      }

      &::-webkit-slider-thumb {
        @include themify($themes) {
          border: .1rem solid themed('brand-primary');
        }
      }
    }

    &::-webkit-slider-runnable-track {
      @include themify($themes) {
        background: themed('brand-5');
        border: .1rem solid themed('brand-5');
      }
      @include track($track-height: .1rem, $track-width: 100%);
      border-radius: .1rem;
    }

    &::-webkit-slider-thumb {
      @include themify($themes) {
        @include thumb($thumb-color: themed('gradient-3'), $thumb-shadow-color: rgba(themed('black'), .2));
      }
      appearance: none;
      margin-top: ((-.1rem * 2 + .1rem) / 2 - 3rem / 2);
      position: relative;
      z-index: 2;
    }

    &::-moz-range-track {
      @include themify($themes) {
        background: themed('brand-5');
        border: .1rem solid themed('brand-5');
      }
      @include track($track-height: .1rem, $track-width: 100%);
      border-radius: .1rem;
      height: .1rem / 2;
    }

    &::-moz-range-thumb {
      @include themify($themes) {
        @include thumb($thumb-color: themed('gradient-3'), $thumb-shadow-color: rgba(themed('black'), .2));
      }
      position: relative;
      z-index: 2;
    }

    &::-ms-track {
      @include track($track-height: .1rem, $track-width: 100%);
      background: transparent;
      border-color: transparent;
      border-width: (3rem / 2) 0;
      color: transparent;
    }

    &::-ms-fill-lower {
      @include themify($themes) {
        background: darken(themed('brand-5'), 5%);
        border: .1rem solid themed('brand-5');
      }
      border-radius: (.1rem * 2);
    }

    &::-ms-fill-upper {
      @include themify($themes) {
        background: themed('brand-5');
        border: .1rem solid themed('brand-5');
      }
      border-radius: (.1rem * 2);
    }

    &::-ms-thumb {
      @include themify($themes) {
        @include thumb($thumb-color: themed('gradient-3'), $thumb-shadow-color: rgba(themed('black'), .2));
      }
      margin-top: .1rem / 4;
      position: relative;
      z-index: 2;
    }

    &:disabled {
      &::-webkit-slider-thumb,
      &::-moz-range-thumb,
      &::-ms-thumb,
      &::-webkit-slider-runnable-track,
      &::-ms-fill-lower,
      &::-ms-fill-upper {
        cursor: not-allowed;
      }
    }
  }
}
